<template>
  <table v-if="firstStation" class="ptd__table">
    <caption v-if="currentSettings.showStationName">
      {{
        firstStation.attributes.station_name
      }}
    </caption>
    <thead v-if="currentSettings.showHeader">
    <tr>
      <th>{{ t("Line") }}</th>
      <th>{{ t("Destination") }}</th>
      <th>{{ t("Departure") }}</th>
      <th>{{ t("Platform") }}</th>
    </tr>
    </thead>
    <tr v-for="dep in firstStation.attributes.departures.slice(0, 10)" :key="dep.uid">
      <td>{{ dep.transit_type }}{{ dep.line }}</td>
      <td>{{ dep.direction }}</td>
      <td>
        {{ formatDepartureTime(dep.departure) }}
        <span v-show="dep.delay_minutes != null">
            + {{ dep.delay_minutes }}</span
        >
      </td>
      <td>{{ dep.platform }}</td>
    </tr>
  </table>
</template>

<script>
/**
 * @typedef {Object} PublicTransport
 * @property {PublicTransportAttributes} attributes
 *
 * @typedef {Object} PublicTransportAttributes
 * @property {string} station_name
 * @property {PublicTransportDepartures[]} departures
 *
 * @typedef {Object} PublicTransportDepartures
 * @property {string} uid
 * @property {string} departure
 * @property {string} line
 * @property {string} direction
 * @property {string} transit_type
 * @property {string} platform
 * @property {number} delay_minutes
 */
module.exports = {
  name: "public-transport-departures",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentStyles: {
      type: Object,
      required: true
    },
    records: {
      type: Array,
      required: true,
      default: function () {
        return [];
      }
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  computed: {
    // FIXME: Workaround until widgets can specify that they can only process a single source.
    /*
     * @returns {PublicTransport} station metadata and departures
     */
    firstStation() {
      return this.records[0]
    },
    timezone: function () {
      // FIXME: Remove once browser gets proper timezone from OS
      return this.$store.state.settings.system_timezone.attributes.value;
    }
  },
  methods: {
    /**
     * Formats a datetime string to the current locale and timezone.
     * @param {string} datetime - an ISO8601 parseable datetime string.
     * @returns {string} the formatted given datetime
     */
    formatDepartureTime(datetime) {
      return new Intl.DateTimeFormat(this.language, {
        hour: "2-digit",
        minute: "2-digit",
        timeZone: this.timezone
      }).format(Date.parse(datetime));
    }
  },
  locales: {
    deDe: {
      Line: "Linie",
      Destination: "Ziel",
      Departure: "Abfahrt",
      Platform: "Gleis"
    },
    frFr: {
      Line: "Ligne",
      Destination: "Destination",
      Departure: "Départ",
      Platform: "Piste"
    },
    esEs: {
      Line: "Línea",
      Destination: "Destino",
      Departure: "Salida",
      Platform: "Pista"
    },
    plPl: {
      Line: "Linia",
      Destination: "Przeznaczenie",
      Departure: "Wyjazd",
      Platform: "Tor"
    },
    koKr: {
      Line: "선",
      Destination: "목적지",
      Departure: "출발",
      Platform: "선로"
    }
  }
};
</script>
<style>
.ptd__table {
  width: 100%;
}
</style>
